﻿'use strict';
angular.module('templates', []);
var app = angular.module('restaurant',
  ['ionic', 'templates', 'angularMoment', 'angular.filter', 'AMS.CoreCommunications', 'AMS.CorePlugins', 'ionic-datepicker', 'ionic-timepicker', 'ngAnimate', 'ngCordova']);

app.run(function ($ionicPlatform, $rootScope, $ionicLoading, $state, $ionicPopup, Notifications, $ionicHistory, $cordovaInAppBrowser) {
    $ionicPlatform.ready(function () {
        if (window.cordova && window.cordova.plugins.Keyboard) {
            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            cordova.plugins.Keyboard.disableScroll(true);
        }
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleDefault();
        }

        Notifications.initialize()

    });

    //settings.roSettigns();

    // loader event
    $rootScope.$on('$stateChangeStart',
      function (event, toState) {
          $rootScope.$broadcast('showloader');
      });
    $rootScope.$on('showloader', function () {
        $ionicLoading.show({
            template: 'Aguarde...'
        });
    });
    $rootScope.$on('hideloader', function () {
        $ionicLoading.hide();
    });


    // Disable BACK button on home
    $ionicPlatform.registerBackButtonAction(function (event) {
        if ($state.current.name == "app.home") { // your check here
            $ionicPopup.confirm({
                title: 'Sair?',
                template: 'Têm a certeza?',
                buttons: [
                      { text: 'Sair', onTap: function(e) { return true; } },
                      {
                          text: '<b>Ficar</b>',
                          type: 'button-assertive',
                          onTap: function(e) {
                              return false;
                          }
                      }]
            }).then(function (res) {
                if (res) {
                    ionic.Platform.exitApp();
                }
            })
        }
        else {
            navigator.app.backHistory();
        }
    }, 100);

    $rootScope.GO =function(state){

        $ionicHistory.nextViewOptions({
            disableAnimate: true,
            disableBack: true
        });
        $state.go(state);

    }
    $rootScope.GO2 = function (state) {
         
        $state.go(state);

    }

    $rootScope.visitSite = function () {
        console.log("visitSite")
       
        $cordovaInAppBrowser.open("http://appmobile.solutions", "_system");
    }
    


})  // VIEWS AND THEIR CONTROLLERS
  .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider, $compileProvider) {
      $ionicConfigProvider.backButton.text(' ').icon('ion-chevron-left');
 

      $stateProvider
        .state('app', {
            url: '/app',
            abstract: true,
            templateUrl: 'menu.html',
            controller: 'AppCtrl'
        })
        .state('app.userpage2', {
            url: '/userpage2',
            views: {
                'menuContent': {
                    templateUrl: 'userpage2.html',
                    controller: 'user2Ctrl'
                }
            }
        })
          	.state('app.wordpress', {
          	    url: '/wordpress',
          	    views: {
          	        'menuContent': {
          	            templateUrl: 'wordpress-articles.html',
          	            controller: 'WordpressArticlesController'
          	        }
          	    }
          	})
           .state('app.home', {
               url: '/home',
               views: {
                   'menuContent': {
                       templateUrl: 'home.html',
                       controller: 'homeCtrl'
                   }
               }
           })
             .state('app.near', {
                 url: '/near',
                 views: {
                     'menuContent': {
                         templateUrl: 'near.html',
                         controller: 'nearCtrl'
                     }
                 }
             })
        .state('app.cervejas', {
            url: '/cervejas',
            views: {
                'menuContent': {
                    templateUrl: 'cervejas.html',
                    controller: 'cervejasCtrl'
                }
            }
        })
        .state('app.ocopo', {
            url: '/ocopo',
            views: {
                'menuContent': {
                    templateUrl: 'ocopo.html',
                    controller: 'ocopoCtrl'
                }
            }
        })
            .state('app.parceiros', {
                url: '/parceiros',
                views: {
                    'menuContent': {
                        templateUrl: 'parceiros.html',
                        controller: 'parceirosCtrl'
                    }
                }
            })
             .state('app.festival', {
                 url: '/festival',
                 views: {
                     'menuContent': {
                         templateUrl: 'festival.html',
                         controller: 'festivalCtrl'
                     }
                 }
             })
          .state('app.beermile', {
              url: '/beermile',
              views: {
                  'menuContent': {
                      templateUrl: 'beermile.html',
                      controller: 'beermileCtrl'
                  }
              }
          })
            .state('app.dishdetails', {
                url: '/dishdetails/:dishid',
                views: {
                    'menuContent': {
                        templateUrl: 'dish-details.html',
                        controller: 'dishDetailsCtrl'
                    }
                }
            })
              .state('app.programa', {
                  url: '/programa',
                  views: {
                      'menuContent': {
                          templateUrl: 'programa.html',
                          controller: 'programaCtrl'
                      }
                  }
              })
            .state('app.bares', {
                url: '/bares',
                views: {
                    'menuContent': {
                        templateUrl: 'bares.html',
                        controller: 'baresCtrl'
                    }
                }
            })
            .state('app.restaurantes', {
                url: '/restaurantes',
                views: {
                    'menuContent': {
                        templateUrl: 'restaurantes.html',
                        controller: 'restaurantesCtrl'
                    }
                }
            })
      .state('app.about', {
          url: '/about',
          views: {
              'menuContent': {
                  templateUrl: 'about.html',
                  controller: 'aboutCtrl'
              }
          }
      })
        .state('app.contact', {
            url: '/contact',
            views: {
                'menuContent': {
                    templateUrl: 'contact.html',
                    controller: 'contactCtrl'
                }
            }
        })
        .state('app.walkthrough', {
            url: '/walkthrough',
            views: {
                'menuContent': {
                    templateUrl: 'templates/walkthrough.html',
                    controller: 'walkthrough'
                }
            }
        })
      ;

      // if none of the above states are matched, use this as the fallback
      var appFirstRun = localStorage.getItem('appFirstRun');

      if (appFirstRun === 'true') {
          $urlRouterProvider.otherwise('/app/home');
      }
      else {
          $urlRouterProvider.otherwise('/app/walkthrough');
      }

      //if(appFirstRun === 'true'){
      //  var username = localStorage.getItem('username');
      //  // redirect if user present
      //  if (username) {
      //    // $state.go('app.userPage');
      //    $urlRouterProvider.otherwise('/app/userpage');
      //  }
      //  else {
      //    $urlRouterProvider.otherwise('/app/adduser');
      //  }
      //}
      //else {
      //  $urlRouterProvider.otherwise('/app/walkthrough');
      //}
      //$urlRouterProvider.otherwise('/app/userpage');


  });
