/*global app */
'use strict';
app
.controller('dishDetailsCtrl', ['$scope', '$stateParams', '$filter', 'dataservice', 'appConfig', '$ionicLoading', '$http','$compile',"$cordovaLaunchNavigator",
  function ($scope, $stateParams, $filter, dataservice, appConfig, $ionicLoading, $http, $compile, $cordovaLaunchNavigator) {
     

   
    var id = $stateParams.dishid;

    $scope.dish = {};
    var url = appConfig.URL_WEB_API + "/GetZomato?id=" + id.toString();
    console.log("url", url)
    $http.get(url)
             .success(function (data, status, headers, config) {
                 // this callback will be called asynchronously
                 // when the response is available
                 console.log("data DISH", data);
                 $scope.dish= data;
              
                 $ionicLoading.hide();
                 initialize();
             })
             .error(function (data, status, headers, config) {
                 // called asynchronously if an error occurs
                 // or server returns response with an error status.
                 console.log('ERROR (About):' + status, data);
                  
             });
    $scope.$on('$ionicView.enter', function () {
        $ionicLoading.hide();
    });
        

    

    $scope.DoGPS = function () {
        
       
        $cordovaLaunchNavigator.navigate([$scope.dish.location.latitude, $scope.dish.location.longitude], function () {
                 // alert("GPS Aberto!");
              }, function (err) {
                  console.log("err", err);
                  alert("Erro Abrir GPS!");
              });


    
    }

    function initialize() {

        var myLatlng = new google.maps.LatLng($scope.dish.location.latitude, $scope.dish.location.longitude);

        var mapOptions = {
            center: myLatlng,
            zoom: 16,
            mapTypeId: google.maps.MapTypeId.ROADMAP
        };
        var map = new google.maps.Map(document.getElementById("map"),
            mapOptions);

        //Marker + infowindow + angularjs compiled ng-click
        var contentString = "<div>" + $scope.dish.name + "</div>";
        var compiled = $compile(contentString)($scope);

        var infowindow = new google.maps.InfoWindow({
            content: compiled[0]
        });

        var marker = new google.maps.Marker({
            position: myLatlng,
            map: map,
            icon : 'https://developers.google.com/maps/documentation/javascript/examples/full/images/beachflag.png',
            title: $scope.dish.name
        });

        google.maps.event.addListener(marker, 'click', function () {
            infowindow.open(map, marker);
        });

        $scope.map = map;
        console.log("MAPPPP", $scope.map)
    }
   
    
}]);