﻿/*global app */
'use strict';
app
.controller('nearCtrl', [
	'$scope', 
	'$stateParams', 
	'$timeout',
	'$ionicLoading', 
	'appConfig', 
	'dataservice', '$cordovaGeolocation','$compile','$http','$cordovaLaunchNavigator',
	function(
		$scope, 
		$stateParams, 
		$timeout,
		$ionicLoading,
		appConfig, 
		dataservice, $cordovaGeolocation, $compile, $http, $cordovaLaunchNavigator
		){
	 
	    $scope.$on('$ionicView.enter', function () {
	        $ionicLoading.hide();
	    });

	    var posOptions = { timeout: 10000, enableHighAccuracy: false };
	    $cordovaGeolocation
            .getCurrentPosition(posOptions)
            .then(function (position) {
                $scope.location = position.coords;
                initialize();
                AddPoints();
            }, function (err) {
                // error
                initialize();
                AddPoints();
            });



	    function initialize() {
	        var myLatlng = null;
	        if (!$scope.location)
	            myLatlng = new google.maps.LatLng(38.7222524, -9.139336599999979);
	        else
	            myLatlng = new google.maps.LatLng($scope.location.latitude, $scope.location.longitude);

	        var mapOptions = {
	            center: myLatlng,
	            zoom: 10,
	            mapTypeId: google.maps.MapTypeId.ROADMAP
	        };
	        var map = new google.maps.Map(document.getElementById("map"),
                mapOptions);

	        //Marker + infowindow + angularjs compiled ng-click
	        var contentString = "<div>Minha Posição</div>";
	        var compiled = $compile(contentString)($scope);

	        var infowindow = new google.maps.InfoWindow({
	            content: compiled[0]
	        });

	        var marker = new google.maps.Marker({
	            position: myLatlng,
	            map: map, 
	            title: "Minha Posição"
	        });
	        marker.setAnimation(google.maps.Animation.BOUNCE);

	        google.maps.event.addListener(marker, 'click', function () {
	            infowindow.open(map, marker);
	        });

	        $scope.map = map; 
	    }



	    function AddPoints() {
	       
	         
	        $http.get(appConfig.URL_BO_CONTENT + "APPCONTENT/_CLIENTES/LISBONBEERWEEK/localizacoes.json")
                     .success(function (data, status, headers, config) {
                         

                         console.log("lcoalizco", data);
                         angular.forEach(data.data, function (obj, idx) {
                             console.log("obj", obj);
                             var myLatlng = new google.maps.LatLng(obj.latitude, obj.longitude);

                             var marker = new google.maps.Marker({
                                 position: myLatlng,
                                 map: $scope.map  ,
                                 title: obj.Name,
                                 icon: "http://maps.google.com/intl/en_us/mapfiles/ms/micons/orange-dot.png"
                             });

                             var contentString = "<div style='width:200px !important; overflow:hidden !important; text-align:center !important'><b>" + obj.Name + "</b><br><button class='button button-assertive button-block' ng-click='DoGPS(" + obj.latitude + "," + obj.longitude + ")'>GPS</button></div>";
                             var compiled = $compile(contentString)($scope);

                             var infowindow = new google.maps.InfoWindow({
                                 content: compiled[0]
                             });

                             google.maps.event.addListener(marker, 'click', function () {
                                 infowindow.open($scope.map, marker);
                             });

                         });


                     })
                     .error(function (data, status, headers, config) {
                         // called asynchronously if an error occurs
                         // or server returns response with an error status.
                         console.log('ERROR (About):' + status, data);

                     });
	        
	      
	    }

	    $scope.DoGPS = function (latitude, longitude) {

	        console.log("DoGPSDoGPSDoGPSDoGPS", latitude, longitude)
	        $cordovaLaunchNavigator.navigate([latitude,  longitude], function () {
	            // alert("GPS Aberto!");
	        }, function (err) {
	            console.log("err", err);
	            alert("Erro Abrir GPS!");
	        });



	    }


	
}]);