/*global app */
'use strict';
app
.controller('WordpressArticlesController', [
	'$scope',
	'dataservice',
	'appConfig',
	'$ionicLoading','$http',
function (
	$scope,
 	dataservice,
 	appConfig,
 	$ionicLoading, $http
 ) {
    $scope.imageroot = 'img/packages/';
    function htmlToPlainText() {
        return function (text) {
            return String(text).replace(/<[^>]+>/gm, '');
        };
    }
    $scope.getArticles = function() {
       

        $http.get(appConfig.URL_BO_CONTENT + "APPCONTENT/_CLIENTES/LISBONBEERWEEK/url.json").success(function (data, status, headers, config) {
 
            var url = data.data.URL;
            console.log("getArticles", url)
            $http.get(url).then(function (response) {
                console.log("response", response)
                $scope.articles = [];
                angular.forEach(response.data.posts, function (item) {
                    var imageUrl = item.attachments.length > 0 ? item.attachments[0].images.full.url : null;
                    var tags = [];
                    angular.forEach(item.tags, function (tag) {
                        tags.push(tag.title);
                    });

                    var contentIndex = item.content.indexOf('</p>') + 4;
                    var content = contentIndex === -1 ? item.content : item.content.substring(contentIndex);

                    $scope.articles.push({
                        id: item.id,
                        title: item.title,
                        brief: htmlToPlainText(item.excerpt),
                        image: imageUrl,
                        date: item.date,
                        content: content,
                        author: item.author.name,
                        tags: tags,
                        url: url
                    });
                });

                $ionicLoading.hide();
            }, function (err) {
                $ionicLoading.hide();
                console.log("response err", err)
            });
        });
    }
 
   
    //$scope.$on('$ionicView.enter', function () {
    //    $ionicLoading.hide();
    //});

    $scope.getArticles();

}]);
 