﻿(function () {
    'use strict';

    angular
		.module('AMS.CorePlugins',[])
		.factory('Notifications', Notifications);

    Notifications.$inject = ["NotificationsBO","ENV"];

    /* @ngInject */
    function Notifications(NotificationsBO, ENV) {
      
        var service = {
            initialize : initialize
        };
        return service;
 

        function initialize() {

            var push = PushNotification.init({
                android: {
                    senderID: ENV.senderIdGoogleAndroidNotification
                },
                ios: {
                    alert: "true",
                    badge: "true",
                    sound: "true",
                    clearBadge : "true"
                }
            });

            push.on('registration', function (data) {
                // data.registrationId
               
                NotificationsBO.postRegistrationId(data.registrationId);
               
            });

            push.on('notification', function (data, evt) {
                // data.message,
                // data.title,
                // data.count,
                // data.sound,
                // data.image,
                // data.additionalData
                //change this to good modal to show this message when app is opened
                //alert("notification", data);
                console.log("notificationdata", data);
                console.log("notificationevt", evt);
                
                if (ionic.Platform.isIOS())
                {
                    push.finish(function () {
                        console.log("processing of push data is finished");
                    });
                }
                
                //alert("notification");
            });

            push.on('error', function (e) {
                // e.message
                console.log("error", e);
                //alert("error");
            });

        }



    }
})();
 